import java.io.*;
import java.net.*;


interface ReceiverWindow
{
  public void textReceived( String s );
}

class ReceiverThread
extends Thread
{
  // This thread receives incoming data from a socket and reports it back
  // to the calling window. It runs until the connection closes and will
  // indicate "stop" by reporting a null string.
  ReceiverWindow rwin;
  InputStreamReader isr;

  public ReceiverThread( ReceiverWindow rwin, InputStreamReader isr )
  {
    this.rwin = rwin;
    this.isr = isr;
  }

  public void run()
  {
    String s;
    int i, len;
    char c[] = new char[ 100 ];
    for( ;; ) {
      s = "";
      try {
        len = isr.read( c, 0, 100 );
        if( len < 0 ) {
          rwin.textReceived( null );
          return;
          }
        for( i = 0; i < len; i++ )
          if( c[ i ] != 0 )
            s += c[ i ];
      } catch (InterruptedIOException e) {
        // timeout in input stream
      } catch (IOException e) {
        break;
        //System.err.println("ReceiverThread: " + e.toString());
      }
      if( s.length() > 0 )
        rwin.textReceived( s );
    }
  }
}
